/*
 * PIXELINE'S TWITTER HASHTAG CONVERSATION WORDPRESS PLUGIN _ THE JAVASCRIPT.
 *
*/


/*--- Parsing twitter helpers --- */
String.prototype.parseHashtag = function() {
	return this.replace(/[#]+[A-Za-z0-9-_]+/g, function(t) {
		var tag = t.replace("#", "%23");
		 return t.link("http://search.twitter.com/search?q=" + tag);
	});
};
String.prototype.parseUsername = function() {
	return this.replace(/[@]+[A-Za-z0-9-_]+/g, function(u) {
		var username = u.replace("@", "");
		 return u.link("http://twitter.com/" + username);
	});
};
String.prototype.parseURL = function() {
	return this.replace(/[A-Za-z]+:\/\/[A-Za-z0-9-_]+\.[A-Za-z0-9-_:%&~\?\/.=]+/g, function(url) {
		return url.link(url);
	});
}; 

// ------------------------------------------------------------
// !Plugin: twitter_hashtag_conversation(options)
// ------------------------------------------------------------

(function($) {
	
	$.fn.twitter_hashtag_conversation = function(options) {
		
		var opts = $.extend({}, $.fn.twitter_hashtag_conversation.defaults, options);
		
		return this.each(function() {	
			
			var $this = jQuery(this);
			var o = $.extend({}, opts, $this.data());			
			o.refresh_rate = o.refresh_rate * 1000;
			$.fn.twitter_hashtag_conversation.defaults = o;
			jQuery('.thc_loading', $this).hide().text(o.update_str);
			var pth_interval = setInterval(function(){loadTweets($this);}, o.refresh_rate);
			loadTweets($this , o.time);		
		});
	};
	

	function loadTweets($obj) {
		var url = $obj.data('twturl');				
		var $thc_loading = jQuery('.thc_loading', $obj).stop().slideDown();
		
		if (url) {
			jQuery.getJSON(url, function(data){
				var tweet_html = '';
				$thc_loading.stop().slideUp();
				jQuery.each(data.results, function(i, tweet) {
					if (tweet.text !== undefined) {
						var hours = jQuery.fn.twitter_hashtag_conversation.prettyDate(tweet.created_at);
						var twitter_user = tweet.from_user;
						var user_url = 'http://www.twitter.com/' + twitter_user;
						var image_url = tweet.profile_image_url;
						var tweet_url = 'http://www.twitter.com/' + twitter_user + '/status/' + tweet.id;
						var text = tweet.text;
						text = text.parseURL().parseUsername().parseHashtag(); // Build the html string for the current tweet
						tweet_html += '<li class="thts-post ' + tweet.created_at + '"><a href="' + user_url + '" class="thts-profile"><img src="' + image_url + '" alt="' + twitter_user + '" class="thts-profile-thumb"/></a><p class="thts-message"><span class="thts-date">' + hours + '</span><a href="' + user_url + '" class="thts-profile-username">' + tweet.from_user + '</a>' + text + ' <a href="' + tweet_url + '" class="thts-sourcelink" title="Le lire sur twitter.com">&raquo;</a></p></li>';
					}
				});
				
				jQuery('.tht_tweet_container', $obj).html(tweet_html);
			});
		}
		
	};
	$.fn.twitter_hashtag_conversation.defaults = {
		refresh_rate: 30,
		update_str: 'Loading tweets…',
		right_now:"Right now", 
		onemin_ago:"1 minute ago",
		xmin_ago:"{TIME} minutes ago",
		onehour_ago:"1 hour ago",
		xhours_ago:"1 hour ago",
		yesterday:"Yesterday",
		xdays_ago:"{TIME} days ago",
		xweeks_ago:"{TIME} weeks ago"	
	};
	
	$.fn.twitter_hashtag_conversation.prettyDate = function(date) { 
	/*
	 * An adaptation of "JavaScript Pretty Date" by John Resig
	 * Copyright (c) 2011 John Resig (ejohn.org)
	 * Licensed under the MIT and GPL licenses.
	 */
	// Takes an ISO time and returns a string representing how
	// long ago the date represents.
	var time=this.defaults;
	var date = new Date((date || "").replace(/-/g, "/").replace(/TZ/g, " "));
	var diff = (((new Date()).getTime() - date.getTime()) / 1000);
	var day_diff = Math.floor(diff / 86400);
	if (isNaN(day_diff) || day_diff < 0 || day_diff >= 31) return;
	var diffminutes = Math.floor(diff / 60);

	var xmin_ago = time.xmin_ago.replace('{TIME}', Math.floor(diff / 60));
	var xhours_ago = time.xhours_ago.replace('{TIME}', Math.floor(diff / 3600));
	var xdays_ago = time.xdays_ago.replace('{TIME}', day_diff);
	var xweeks_ago = time.xweeks_ago.replace('{TIME}', Math.ceil(day_diff / 7));
	return day_diff == 0 && (diff < 60 && time.right_now || diff < 120 && time.onemin_ago || diff < 3600 && xmin_ago || diff < 7200 && time.onehour_ago || diff < 86400 && xhours_ago) || day_diff == 1 && time.yesterday || day_diff < 7 && xdays_ago || day_diff < 31 && xweeks_ago;
} 
})(jQuery);


// ------------------------------------------------------------
// !RUNTIME
// ------------------------------------------------------------

jQuery(function($) {
		jQuery('.twitter-hash-tag').twitter_hashtag_conversation();
});
